#!/usr/bin/env python3
from time import time
from ev3dev2.sensor.lego import ColorSensor
from ev3dev2.motor import MoveTank,OUTPUT_B,OUTPUT_C

cs=ColorSensor()
th=55                       # しきい値(%)

rbt=MoveTank(OUTPUT_B,OUTPUT_C)
sp=30                       # スピード(%)

rbt.on(sp,sp)  # 最初はライン上にあるので直進

while True:
    if cs.reflected_light_intensity >= th:  # ラインから外れて白い部分に来た
        ti=0.0
        online=False
        dir=1                    # 一番はじめは左ターンして探索
        while online==False:
            if dir==1:
                rbt.on(-sp,sp)   # 左ターンしてラインを探索
            else:
                rbt.on(sp,-sp)   # 右ターンしてラインを探索

            ti += 0.1;           # 探索時間を長くしていく
            if ti > 1.2:         # 探索時間内にラインを見つけられなかった場合
                ti=0.2          
                rbt.on(-sp,-sp)  # 少し後退する。

            ct=time();             # 現在時刻
            while time()-ct < ti:  # 探索時間
                if cs.reflected_light_intensity < th:
                    rbt.on(sp,sp)  # ライン上は，直進
                    online=True
                    break

            dir = -dir           # ターンの方向を交換
